;***********************************************************
;* Title: high border in interlace using GTIA mode (GR.10) *
;* Author: pavros                                          *
;* Date: 2009-08-11                                        *
;* REMARK: This program includes code generating           *
;* VSYNC sequence developed by  Gary "Rybags" Ryan.        *
;* The code finds within vsync1 subroutine.                *
;***********************************************************

	lda $14
	cmp $14
	beq *-2         ;wait for new screen frame

	lda #$00
	sta nmien       ;disable all NMI
	sta nmires
	sei ;turn off all IRQ
	lda #$00
	;sta dmactls
	sta dmactl      ;disable screen dma

	lda #BANKSTD
	sta portb

	lda #lo(nmiCommonHnd)
	sta nmivec
	lda #hi(nmiCommonHnd)
	sta nmivec+1
	lda #lo(irqCommonHnd)
	sta irqvec
	lda #hi(irqCommonHnd)
	sta irqvec+1

	lda #lo(dliHnd)   ;setup DLI vector
	sta dliv
	lda #hi(dliHnd)
	sta dliv+1

	lda #lo(dList1)  ;setup Display List vector
	sta dlptr
	;sta dlptrs
	lda #hi(dList1)
	sta dlptr+1
	;sta dlptrs+1


	ldx #4
colLoop
	lda colors2,x
	sta colpf0,x
	dex
	bpl colLoop

	lda #$00
	sta vblCnt
	sta vblCnt+1

	lda #$C0
	sta nmien       ;enable VBLKI and DLI
	lda #$22
	;sta dmactls
	sta dmactl      ;enable screen dma

	;cli

	lda #$00
	sta $D01D
	lda #$03
	sta sizep0
	sta sizep1
	lda #$AA
	sta grafp0
	sta grafp1
	lda #$82
	sta colpm0
	lda #$C6
	sta colpm1

loop
	lda #$18
loop1
	clc
	sbc #1
	bne loop1
	lda vblCnt+1
	and #$01
	;and #$00
	beq loop2
	lda #$FF
loop2
	sta colbakMask
	sta dliColbakMask
;	sta dliColbakMask2
	sta vblColpf1Mask
	lda random
colbakMask = * + 1
	and #$FF
	sta colbak
	tax
	lda vcount
	cmp #$70
	bcc loop
	txa
	sta colpf1 ;this for last two lines of screen until vblk interrupt takes over border color changes
	sta colpf2
	jmp loop


colors
	db $24,$F8,$EC,$46,$00

colors2
	db $00,$24,$F8,$EC,$00


vBlkInt
	pha
	txa
	pha
	tya
	pha
	lda vblCnt
	tay
	clc
	adc #1
	sta vblCnt
	lda vblCnt+1
	adc #0
	sta vblCnt+1

	lda #$23
	sta dmactl

	lda #$81  ;GTIA mode while border for better showing sprites
	sta $D01B
	ldx #$6C
	jsr modBorderColor
	lda #$01  ;turn off GTIA mode
	;sta $D01B  ;this makes synchronizaion problems - strange

	lda vblCnt
	sta hposp0
	eor #$FF
	sec
	sbc #$20
	sta hposp1

	tya
	and #$01
	bne vBlkInt1

	jsr vsync1
	lda #lo(dList1)  ;setup Display List vector
	sta dlptr
	lda #hi(dList1)
	sta dlptr+1
	jmp vBlkInt2

vBlkInt1
	jsr vsync2
	lda #lo(dList2)  ;setup Display List vector
	sta dlptr
	lda #hi(dList2)
	sta dlptr+1

vBlkInt2
	lda #$23
	sta dmactl

	ldx #4
colTabIdx = * + 1
;	ldy #4
	ldy #9
vcolLoop
	cpx #1
	beq vBlkInt3	;skip colpf1 here
	cpx #2
	beq vBlkInt3	;skip colpf2 here
	lda colors,y
	sta colpf0,x
vBlkInt3
	dey
	dex
	bpl vcolLoop

;	lda colTabIdx
;	cmp #4
;	bne vBlkInt2
;	lda #9
;	bne vBlkInt3
;vBlkInt2
;	lda #4
;vBlkInt3
;	sta colTabIdx

	sta wsync
	nop
	lda #$81  ;GTIA mode while border for better showing sprites
	sta $D01B
	ldx #$80
	jsr modBorderColor
	lda #$01  ;turn off GTIA mode
	sta $D01B

	pla
	tay
	pla
	tax
	pla
	rti


dliHnd
	pha
	lda vcount
	asl a
	bmi dliHnd3
	lda #$00
	sta nmien
	lda #$22
	sta dmactl
	lda colors+1+5
	sta colpf1
	lda colors+2+5
	sta colpf2
	lda colors+3+5
	sta colpf3
dliHnd1
	sta wsync
	lda #$C0
	sta $D01B
	;nop
	;nop
	;nop
	;nop
	;nop
	lda random
dliColbakMask = * + 1
	and #$FF
	sta colbak
	;nop
	;nop
	
	nop
	nop
	lda #$01
	sta $D01B

;	lda #$C0
;	sta wsync
;	sta $D01B
;	;nop
;	;nop
;	;nop
;	;nop
;	;nop
;	lda random
;dliColbakMask2 = * + 1
;	and #$FF
;	sta colbak
;	;nop
;	;nop
;	
;	nop
;	nop
;	nop
;	lda #$00
;	sta $D01B

	inc dliCnt
dliCnt = * + 1
	lda #$00
	cmp #$C8
;	cmp #$64
	bcc dliHnd1
	lda vblCnt
	and #$01
	;bne dliHnd2
	lda #$23
	sta wsync
	sta dmactl

dliHnd2
	lda #$00
	sta dliCnt
	lda #$C0
	sta nmires
	sta nmien

	;lda #$41  ;GTIA mode while border for better showing sprites
	;sta $D01B
	
	pla
	rti

dliHnd3
	sta wsync
	ldx #$1
	jsr modBorderColor
	sta wsync
	nop
	nop
	lda #$81  ;GTIA mode while border for better showing sprites
	sta $D01B
	pla
	rti


waitvc
	cmp vcount
	bne waitvc
	rts


vsync1
	lda #$88
	jsr waitvc
    lda #0
    sta $d017
    sta $d018
    sta $d01a
    sta wsync
    ldy #3
    sta wsync
    sta wsync
; first line of vsync... half line at blanking level, second half at sync level
    nop; 105
    sty dmactl; 109
    ldx #7; 111
;    sta dmactl; 55 (2)
; Refresh cycles 26 30 34 38 42 46 50 54 58
vsync21
    dex
    bne vsync21; 5*X-1=34=31 (+2 Ref)= 33
    ldx #3; 36 (1)
    nop; 39 (1)
    nop; 41
    nop; 44 (1)
    nop; 47 (1)
    nop; 49
    sta dmactl; 55 (2)
    nop; 57
    stx vscount; 62 (1)
    ldx #7; 63
; Refresh cycles 26 30 34 38 42 46 50 54 58
vsync22
    dex
    bne vsync22; 5*X-1 = 34 = 97,
    sty dmactl; 101 get HSync pulses back in normal order
    nop; 103
    nop; 105
    nop; 107
    sta dmactl; 111
    dec vscount; 116 = 2
    beq vsyncend; 4
    ldx #5; 6
vsync23
    dex
    bne vsync23; 5*X-1 = 24 (+ 2 Ref) = 32
    ldx #6; 35 (1)
    nop; 37
    nop; 40 (1)
    nop; 43 (1)
    nop; 45
    sty dmactl; 51 (2)
    nop; 53
    sta dmactl; 59 (2)
    nop; 61
    nop; 63
    nop; 65
    jmp vsync22; 68
; Refresh cycles 26 30 34 38 42 46 50 54 58
vsyncend
    lda #$90 ;$91 can also be here
    jsr waitvc
;vblankend
	rts

	
vsync2
    lda #$88
    jsr waitvc
    lda #0
    sta $d017
    sta $d018
    sta $d01a
    sta wsync
    ldy #3
    sta wsync
    ldx #2
    stx vscount
    sta wsync
    nop
    nop
    sta dmactl
    ldx #6
vsync11
    dex
    bne vsync11
    nop
    nop
    nop
    nop
    nop
    nop
    sty dmactl
    nop
    sta dmactl
    ldx #7
vsync12
    dex
    bne vsync12
	nop
    sty dmactl
    nop
    nop
    nop
    sta dmactl
    nop
    ldx #4
    dec vscount
    bne vsync11
    ldx #5
vsync13
    dex
    bne vsync13
    nop
    nop
    nop
    sty dmactl
    nop
    sta dmactl
    sty dmactl
	;nop
	;nop
	;nop
	;nop
    ldx #7
vsync14
    dex
    bne vsync14
    nop
    nop
    nop
    nop
    sta dmactl
;vsyncend
    lda #$90
    jsr waitvc
;vblankend
    rts


modBorderColor
	lda random
vblColpf1Mask = * + 1
	and #$FF
	sta colbak
	sta colpf3
	cmp #$80
	bne * + 2
	dex
	bne modBorderColor
	rts


lms_F_line_x10 macro
        db $4F,lo(picAdr+80*\10),hi(picAdr+80*\10)
        db $4F,lo(picAdr+80*\11),hi(picAdr+80*\11)
        db $4F,lo(picAdr+80*\12),hi(picAdr+80*\12)
        db $4F,lo(picAdr+80*\13),hi(picAdr+80*\13)
        db $4F,lo(picAdr+80*\14),hi(picAdr+80*\14)
        db $4F,lo(picAdr+80*\15),hi(picAdr+80*\15)
        db $4F,lo(picAdr+80*\16),hi(picAdr+80*\16)
        db $4F,lo(picAdr+80*\17),hi(picAdr+80*\17)
        db $4F,lo(picAdr+80*\18),hi(picAdr+80*\18)
        db $4F,lo(picAdr+80*\19),hi(picAdr+80*\19)
      endm

lms_F_line_odd_x10 macro
        db $4F,lo(picAdr+80*\10+40),hi(picAdr+80*\10+40)
        db $4F,lo(picAdr+80*\11+40),hi(picAdr+80*\11+40)
        db $4F,lo(picAdr+80*\12+40),hi(picAdr+80*\12+40)
        db $4F,lo(picAdr+80*\13+40),hi(picAdr+80*\13+40)
        db $4F,lo(picAdr+80*\14+40),hi(picAdr+80*\14+40)
        db $4F,lo(picAdr+80*\15+40),hi(picAdr+80*\15+40)
        db $4F,lo(picAdr+80*\16+40),hi(picAdr+80*\16+40)
        db $4F,lo(picAdr+80*\17+40),hi(picAdr+80*\17+40)
        db $4F,lo(picAdr+80*\18+40),hi(picAdr+80*\18+40)
        db $4F,lo(picAdr+80*\19+40),hi(picAdr+80*\19+40)
      endm


 org dl1Adr


;dList
;
;	db	$70,$70,$30
;	db	$4E,lo(picAdr),hi(picAdr)
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E
;	db	$4E,lo(picAdr+$FF0),hi(picAdr+$FF0)
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
;	db	$0E
;	db	$41,lo(dList2),hi(dList2)


dList1

	db	$70,$70,$B0
	lms_F_line_x10 0
	lms_F_line_x10 1
	lms_F_line_x10 2
	lms_F_line_x10 3
	lms_F_line_x10 4
	lms_F_line_x10 5
	lms_F_line_x10 6
	lms_F_line_x10 7
	lms_F_line_x10 8
	lms_F_line_x10 9
	;lms_F_line_x10 10 ;4k boundary problem
	lms_F_line_x10 11
	lms_F_line_x10 11
	lms_F_line_x10 12
	lms_F_line_x10 13
	lms_F_line_x10 14
	lms_F_line_x10 15
	lms_F_line_x10 16
	lms_F_line_x10 17
	lms_F_line_x10 18
	lms_F_line_x10 19
	db	$70,$70,$A0
	db	$0F
	db	$41,lo(dList2),hi(dList2)


 org dl2Adr


dList2

	db	$70,$70,$B0
	lms_F_line_odd_x10 0
	lms_F_line_odd_x10 1
	lms_F_line_odd_x10 2
	lms_F_line_odd_x10 3
	lms_F_line_odd_x10 4
	lms_F_line_odd_x10 5
	lms_F_line_odd_x10 6
	lms_F_line_odd_x10 7
	lms_F_line_odd_x10 8
	lms_F_line_odd_x10 9
	;lms_F_line_odd_x10 10 ;4k boundary problem
	lms_F_line_odd_x10 11
	lms_F_line_odd_x10 11
	lms_F_line_odd_x10 12
	lms_F_line_odd_x10 13
	lms_F_line_odd_x10 14
	lms_F_line_odd_x10 15
	lms_F_line_odd_x10 16
	lms_F_line_odd_x10 17
	lms_F_line_odd_x10 18
	lms_F_line_odd_x10 19
	db	$70,$70,$A0
	db	$0F
	db	$41,lo(dList1),hi(dList1)
